Experiments
Set the datasource-driven assignment of an experiment
Adding it switches the experiment to datasource-driven assignment (draft or ready only). Its datasource, its conditions and their order stay editable until the experiment is decided, inconclusive or archived. The datasource must be an active datasource of the company. Conditions may be incomplete in draft; from ready on they must be complete.
PUT
/
experiments
/
{id}
/
datasource-assignment
Set the datasource-driven assignment of an experiment
curl --request PUT \
--url https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"datasourceId": "<string>",
"conditions": [
{
"variantId": "<string>",
"type": "and",
"rules": [
{
"field": "<string>",
"operation": "$eq",
"values": [
"<string>"
]
}
]
}
]
}
'import requests
url = "https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment"
payload = {
"datasourceId": "<string>",
"conditions": [
{
"variantId": "<string>",
"type": "and",
"rules": [
{
"field": "<string>",
"operation": "$eq",
"values": ["<string>"]
}
]
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
datasourceId: '<string>',
conditions: [
{
variantId: '<string>',
type: 'and',
rules: [{field: '<string>', operation: '$eq', values: ['<string>']}]
}
]
})
};
fetch('https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'datasourceId' => '<string>',
'conditions' => [
[
'variantId' => '<string>',
'type' => 'and',
'rules' => [
[
'field' => '<string>',
'operation' => '$eq',
'values' => [
'<string>'
]
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment"
payload := strings.NewReader("{\n \"datasourceId\": \"<string>\",\n \"conditions\": [\n {\n \"variantId\": \"<string>\",\n \"type\": \"and\",\n \"rules\": [\n {\n \"field\": \"<string>\",\n \"operation\": \"$eq\",\n \"values\": [\n \"<string>\"\n ]\n }\n ]\n }\n ]\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"datasourceId\": \"<string>\",\n \"conditions\": [\n {\n \"variantId\": \"<string>\",\n \"type\": \"and\",\n \"rules\": [\n {\n \"field\": \"<string>\",\n \"operation\": \"$eq\",\n \"values\": [\n \"<string>\"\n ]\n }\n ]\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"datasourceId\": \"<string>\",\n \"conditions\": [\n {\n \"variantId\": \"<string>\",\n \"type\": \"and\",\n \"rules\": [\n {\n \"field\": \"<string>\",\n \"operation\": \"$eq\",\n \"values\": [\n \"<string>\"\n ]\n }\n ]\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"status": "success",
"program": "<string>",
"version": "<string>",
"datetime": "<string>",
"message": "<string>",
"data": {
"type": "holdout",
"unit": "user",
"_id": "<string>",
"companyId": "<string>",
"name": "<string>",
"hypothesis": "<string>",
"successMetric": "unique_conversion",
"status": "draft",
"attachments": [
{
"surface": "workflow",
"resourceId": "<string>",
"attachedAt": "2023-11-07T05:31:56Z"
}
],
"createdBy": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"updatedAt": "2023-11-07T05:31:56Z",
"variants": [
{
"id": "<string>",
"name": "<string>",
"allocation": 123,
"tagValueId": "<string>"
}
],
"baselineVariantId": "<string>",
"resourceGroupIds": [
"<string>"
],
"systemTagKeyId": "<string>",
"scheduledAt": "2023-11-07T05:31:56Z",
"startedAt": "2023-11-07T05:31:56Z",
"readAt": "2023-11-07T05:31:56Z",
"endedAt": "2023-11-07T05:31:56Z",
"outcome": {
"status": "decided",
"routingVariantId": "<string>",
"decidedBy": {
"type": "user",
"userId": "<string>"
},
"validated": true,
"confidence": 123,
"pValue": 123,
"lift": {
"estimate": 123,
"low": 123,
"high": 123
}
},
"archivedAt": "2023-11-07T05:31:56Z",
"datasourceAssignment": {
"datasourceId": "<string>",
"conditions": [
{
"variantId": "<string>",
"type": "and",
"rules": [
{
"field": "<string>",
"operation": "$eq",
"values": [
"<string>"
]
}
]
}
]
}
},
"code": 123
}{
"program": "<string>",
"version": "<string>",
"datetime": "<string>",
"status": "fail",
"code": 404,
"message": "Unable to find experiment",
"data": {
"id": "<string>"
},
"error_code": 9000
}{
"program": "<string>",
"version": "<string>",
"datetime": "<string>",
"status": "fail",
"code": 409,
"message": "Some fields are locked in the current status of the experiment, see `fields`",
"data": {
"id": "<string>",
"status": "<string>",
"fields": [
"name"
]
},
"error_code": 9000
}{
"program": "<string>",
"version": "<string>",
"datetime": "<string>",
"status": "fail",
"code": 422,
"message": "The experiment configuration is invalid",
"data": {
"reason": "<string>"
},
"error_code": 9000
}Authorizations
The access token received from the authorization server in the OAuth 2.0 flow.
Path Parameters
Pattern:
^[0-9a-fA-F]{24}$Was this page helpful?
⌘I
Set the datasource-driven assignment of an experiment
curl --request PUT \
--url https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"datasourceId": "<string>",
"conditions": [
{
"variantId": "<string>",
"type": "and",
"rules": [
{
"field": "<string>",
"operation": "$eq",
"values": [
"<string>"
]
}
]
}
]
}
'import requests
url = "https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment"
payload = {
"datasourceId": "<string>",
"conditions": [
{
"variantId": "<string>",
"type": "and",
"rules": [
{
"field": "<string>",
"operation": "$eq",
"values": ["<string>"]
}
]
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
datasourceId: '<string>',
conditions: [
{
variantId: '<string>',
type: 'and',
rules: [{field: '<string>', operation: '$eq', values: ['<string>']}]
}
]
})
};
fetch('https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'datasourceId' => '<string>',
'conditions' => [
[
'variantId' => '<string>',
'type' => 'and',
'rules' => [
[
'field' => '<string>',
'operation' => '$eq',
'values' => [
'<string>'
]
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment"
payload := strings.NewReader("{\n \"datasourceId\": \"<string>\",\n \"conditions\": [\n {\n \"variantId\": \"<string>\",\n \"type\": \"and\",\n \"rules\": [\n {\n \"field\": \"<string>\",\n \"operation\": \"$eq\",\n \"values\": [\n \"<string>\"\n ]\n }\n ]\n }\n ]\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"datasourceId\": \"<string>\",\n \"conditions\": [\n {\n \"variantId\": \"<string>\",\n \"type\": \"and\",\n \"rules\": [\n {\n \"field\": \"<string>\",\n \"operation\": \"$eq\",\n \"values\": [\n \"<string>\"\n ]\n }\n ]\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.reelevant.com/v2/statistics/experiments/{id}/datasource-assignment")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"datasourceId\": \"<string>\",\n \"conditions\": [\n {\n \"variantId\": \"<string>\",\n \"type\": \"and\",\n \"rules\": [\n {\n \"field\": \"<string>\",\n \"operation\": \"$eq\",\n \"values\": [\n \"<string>\"\n ]\n }\n ]\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"status": "success",
"program": "<string>",
"version": "<string>",
"datetime": "<string>",
"message": "<string>",
"data": {
"type": "holdout",
"unit": "user",
"_id": "<string>",
"companyId": "<string>",
"name": "<string>",
"hypothesis": "<string>",
"successMetric": "unique_conversion",
"status": "draft",
"attachments": [
{
"surface": "workflow",
"resourceId": "<string>",
"attachedAt": "2023-11-07T05:31:56Z"
}
],
"createdBy": "<string>",
"createdAt": "2023-11-07T05:31:56Z",
"updatedAt": "2023-11-07T05:31:56Z",
"variants": [
{
"id": "<string>",
"name": "<string>",
"allocation": 123,
"tagValueId": "<string>"
}
],
"baselineVariantId": "<string>",
"resourceGroupIds": [
"<string>"
],
"systemTagKeyId": "<string>",
"scheduledAt": "2023-11-07T05:31:56Z",
"startedAt": "2023-11-07T05:31:56Z",
"readAt": "2023-11-07T05:31:56Z",
"endedAt": "2023-11-07T05:31:56Z",
"outcome": {
"status": "decided",
"routingVariantId": "<string>",
"decidedBy": {
"type": "user",
"userId": "<string>"
},
"validated": true,
"confidence": 123,
"pValue": 123,
"lift": {
"estimate": 123,
"low": 123,
"high": 123
}
},
"archivedAt": "2023-11-07T05:31:56Z",
"datasourceAssignment": {
"datasourceId": "<string>",
"conditions": [
{
"variantId": "<string>",
"type": "and",
"rules": [
{
"field": "<string>",
"operation": "$eq",
"values": [
"<string>"
]
}
]
}
]
}
},
"code": 123
}{
"program": "<string>",
"version": "<string>",
"datetime": "<string>",
"status": "fail",
"code": 404,
"message": "Unable to find experiment",
"data": {
"id": "<string>"
},
"error_code": 9000
}{
"program": "<string>",
"version": "<string>",
"datetime": "<string>",
"status": "fail",
"code": 409,
"message": "Some fields are locked in the current status of the experiment, see `fields`",
"data": {
"id": "<string>",
"status": "<string>",
"fields": [
"name"
]
},
"error_code": 9000
}{
"program": "<string>",
"version": "<string>",
"datetime": "<string>",
"status": "fail",
"code": 422,
"message": "The experiment configuration is invalid",
"data": {
"reason": "<string>"
},
"error_code": 9000
}